package minpaint;

import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public abstract class DrawingTool extends MouseAdapter{

	Point start;
	Point end;
	PaintPanel panel;
	
	public DrawingTool(PaintPanel panel) {
	    //treba nam referenca na povrsinu
	    //za iscrtavanje kako bi dodavali nove oblike (shape)
	    //i pozivali eksplicitno repaint metod
		this.panel=panel;
	}
	
	@Override
	public void mousePressed(MouseEvent arg0) {
	    //na klik samo postavljamo startnu tacku
		start=arg0.getPoint();
	}
	
	
	@Override
	public void mouseDragged(MouseEvent arg0) {
	    //na povlacenje iscrtavamo trenutni objekat
	    //i pozivamo repaint
		end=arg0.getPoint();
		//to sta ce biti objekat zavisi od aktuelnog
		//alata
		panel.temp=getShape(start, end);
		panel.repaint();
	}
	
	@Override
	public void mouseReleased(MouseEvent arg0) {
	    //na pustanje misa, dodajemo novi oblik
	    //u kolekciju oblika i pozivamo ponovno
	    //iscrtavanje (repaint)
		end=arg0.getPoint();
		panel.shapes.add(getShape(start, end));
		panel.temp=null;
		panel.repaint();
	}
	
	public abstract Shape getShape(Point s, Point e);
}
