package minpaint;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JToolBar;

public class MinipaintGUI extends JFrame {

    int width=500;
    int height=500;
    PaintPanel paintPanel;
    JToolBar toolbar;
    JButton btnRect;
    JButton btnElipse;
    DrawingTool activeTool;
    
    public MinipaintGUI() {
	
	setPreferredSize(new Dimension(width, height));
	center();
	
	setLayout(new BorderLayout());
	//podloga za crtanej
	paintPanel=new PaintPanel();
	getContentPane().add(paintPanel);
	//traka sa dugmicima
	toolbar=new JToolBar();
	//klikom na ovo dugme podesavamo aktivni alat
	//na pravougaonik
	btnRect=new JButton("Rect");
	btnRect.addActionListener(new ActionListener(){
		@Override
		public void actionPerformed(ActionEvent arg0) {
		    /*uklanjamo sve prethodne osluskivace, tj.
		    prethodni aktivni alat
		    imamo dve grupe: 
		    1. regularni mouse osluskivaci, to su oni koji se odnose 
		    na klik, pritisak, pustanje (release) itd..
		    2. mouse motion osluskivac, odnosi se na aktivnosti vezane
		    za pomeranje misa: drag i move
		    */
		    if(activeTool!=null){
			paintPanel.removeMouseListener(activeTool);
			paintPanel.removeMouseMotionListener(activeTool);
			activeTool=null;
		    }
		    //postavljamo novi alat
			activeTool=new RectDrawingTool(paintPanel);
			paintPanel.addMouseListener(activeTool);
			paintPanel.addMouseMotionListener(activeTool);
		}
	});
	toolbar.add(btnRect);
	//sve isto za elipse alat
	btnElipse=new JButton("Elipse");
	btnElipse.addActionListener(new ActionListener(){
		@Override
		public void actionPerformed(ActionEvent arg0) {
		    if(activeTool!=null){
			paintPanel.removeMouseListener(activeTool);
			paintPanel.removeMouseMotionListener(activeTool);
			activeTool=null;
		    }
			activeTool=new ElipseDrawingTool(paintPanel);
			paintPanel.addMouseListener(activeTool);
			paintPanel.addMouseMotionListener(activeTool);
		}
	});
	toolbar.add(btnElipse);
	getContentPane().add(toolbar, BorderLayout.SOUTH);
	
	pack();
	setDefaultCloseOperation(EXIT_ON_CLOSE);
	setVisible(true);
    }
    /**
     * @param args
     */
    public static void main(String[] args) {
	MinipaintGUI gui=new MinipaintGUI();
    }
    
    void center(){
	Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((d.width-width)/2, (d.height-height)/2);
    }

}
